C   INPUT DATA CREATION FOR 3D FINITE ELEMENT METHOD
C         ----- F3DCR.FOR (1997/7) -----
C                BY TAKAYUKI HIRAI
C
      DIMENSION TX(500),TY(500),TZ(500)
      CHARACTER TITLE*40
C
C  ---------- INPUT FUNDAMENTAL VALUE ----------
      OPEN(16,FILE='DD')
      CLOSE(16,STATUS='DELETE')
      OPEN(16,FILE='DD')                                        
      IDD=0
      WRITE(*,2001)
      READ(*,1001) TITLE 
      WRITE(16,1001) TITLE 
      WRITE(*,2007)
      READ(*,*) X1
      WRITE(*,2008)
      READ(*,*) Y1
      WRITE(*,2009)
      READ(*,*) Z1
      WRITE(*,2003)
      READ(*,*) LX
      DO 10 I=1,LX
      WRITE(*,2010) I
   10 READ(*,*) TX(I)
      WRITE(*,2004)
      READ(*,*) LY
      DO 12 I=1,LY
      WRITE(*,2011) I
   12 READ(*,*) TY(I)
      WRITE(*,2005)
      READ(*,*) LZ
      DO 14 I=1,LZ
      WRITE(*,2012) I
   14 READ(*,*) TZ(I)
 1001 FORMAT(A40) 
 2001 FORMAT(/'  --------  CREATION INPUT DATA  --------'
     1    //'  TITLE = ')
 2003 FORMAT(/' X-DIRECTION DIVISION NUMBER = ')
 2004 FORMAT(/' Y-DIRECTION DIVISION NUMBER = ')
 2005 FORMAT(/' Z-DIRECTION DIVISION NUMBER = ')
 2007 FORMAT(/' X-COORDINATE OF BASIS POINT = ') 
 2008 FORMAT(' Y-COORDINATE OF BASIS POINT = ') 
 2009 FORMAT(' Z-COORDINATE OF BASIS POINT = ') 
 2010 FORMAT(' X-DIRECTION DIVIDE LENGTH OF NO.',
     1    I2,' = ') 
 2011 FORMAT(' Y-DIRECTION DIVIDE LENGTH OF NO.',
     1    I2,' = ') 
 2012 FORMAT(' Z-DIRECTION DIVIDE LENGTH OF NO.',
     1    I2,' = ') 
C
C  ------------ CREATE NODE COODINATE ------------
      WRITE(*,2006)
      NELE=LX*LY*LZ
      NODE=4*NELE+3*(LX*LY+LY*LZ+LZ*LX)
     1    +2*(LX+LY+LZ)+1
      WRITE(16,2013) NELE,NODE,1,3
      WRITE(*,2013) NELE,NODE,1,3
      LX1=LX+1
      LY1=LY+1
      LZ1=LZ+1
      N=0
      TZZ=Z1
      DO 21 K=1,LZ1
      DO 21 KK=1,2
      IF(K.EQ.1) GO TO 22
      TZZ=TZZ+TZ(K-1)*0.5
   22 TYY=Y1
      DO 21 J=1,LY1
      DO 21 JJ=1,2
      IF(J.EQ.1) GO TO 23
      TYY=TYY+TY(J-1)*0.5
   23 TXX=X1
      DO 21 I=1,LX1
      II=1
      IF(I.EQ.1) GO TO 24 
      TXX=TXX+TX(I-1)*0.5
   24 IF(K*KK.EQ.1) GO TO 25
      IF(J*JJ.EQ.1) GO TO 25
      IF(I*II.EQ.1) GO TO 25
      IF(II*JJ.EQ.1) GO TO 25
      IF(II*KK.EQ.1) GO TO 25
      IF(JJ*KK.EQ.1) GO TO 25
      N=N+1
      WRITE(16,2014) N,TXX,TYY,TZZ
      WRITE(*,2014) N,TXX,TYY,TZZ
   25 II=2
      IF(I.EQ.1) GO TO 26 
      TXX=TXX+TX(I-1)*0.5
   26 IF(K*KK.EQ.1) GO TO 21
      IF(J*JJ.EQ.1) GO TO 21
      IF(I*II.EQ.1) GO TO 21
      IF(II*JJ.EQ.1) GO TO 21
      IF(II*KK.EQ.1) GO TO 21
      IF(JJ*KK.EQ.1) GO TO 21
      N=N+1
      WRITE(16,2014) N,TXX,TYY,TZZ
      WRITE(*,2014) N,TXX,TYY,TZZ
   21 CONTINUE
      IF(NODE.NE.N) IDD=100
 2006 FORMAT(/)
 2013 FORMAT(4I5)
 2014 FORMAT(I5,3F15.6)      
C
C  ------- CREATE NODE NUMBER OF EACH ELEMENT ------- 
      N=0
      DO 30 K=1,LZ
      DO 30 J=1,LY
      DO 30 I=1,LX
      N=N+1
      N1=(4*LX*LY+3*LY+3*LX+2)*(K-1)
     1    +(3*LX+2)*(J-1)+2*(I-1)+1
      N2=N1+2
      N3=N1+3*LX+4
      N4=N3-2
      N5=N4+4*LX*LY+3*LY
      N6=N5+2
      N7=N6+3*LX+2
      N8=N7-2
      N9=N8-4*LX*LY-6*LX-3*LY-3
      N10=N9+2*LX-I+2
      N11=N10+LX+I
      N12=N10-1
      N13=N12+3*LX*LY-(2*LX+1)*(J-1)+2*LY
      N14=N13+1
      N15=N14+LX+1
      N16=N14+LX
      N17=N16+LX*LY+(2*LX+1)*(J-1)+LY+I
      N18=N17+2*LX-I+2
      N19=N18+LX+I
      N20=N18-1
      WRITE(*,2015) N,N1,N2,N3,N4,N5,N6,N7,N8,N9,N10,
     1    N11,N12,N13,N14,N15,N16,N17,N18,N19,N20,1,0.0
   30 WRITE(16,2015) N,N1,N2,N3,N4,N5,N6,N7,N8,N9,N10,
     1    N11,N12,N13,N14,N15,N16,N17,N18,N19,N20,1,0.0
      WRITE(*,2016)
      WRITE(16,2016)
      WRITE(*,2027)
      WRITE(*,2028)
      WRITE(*,2029)
      WRITE(*,2030)
      WRITE(16,2027)
      WRITE(16,2028)
      WRITE(16,2029)
      WRITE(16,2030)
      IF(IDD.EQ.0) WRITE(*,2019)
      IF(IDD.NE.0) WRITE(*,2020)
 2015 FORMAT(11I4/I8,10I4,F10.7)
 2016 FORMAT('    1  200000.000000       0.200000') 
 2027 FORMAT('    1    1    1    1       0.000000'
     1    ,'       0.000000       0.000000')
 2028 FORMAT('    2    1    1    1       0.000000'
     1    ,'       0.000000       0.000000')
 2029 FORMAT('    3    1    1    1       0.000000'
     1    ,'       0.000000       0.000000')
 2030 FORMAT('99999')
 2019 FORMAT(/'       ----------  FINISH  ----------'/)  
 2020 FORMAT(/'       ------  ERROR   TOTAL NODE ',
     1    'NUMBER DISAGREE  ------'/)
      CLOSE(16,STATUS='KEEP')
      STOP
      END
